The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Messager Class Reference

STK input control message parser. More...

`#include <Messager.h>`

Inheritance diagram for stk::Messager:

## Public Member Functions
| Messager ()
| Default constructor.
| ~Messager ()
| Class destructor.
void | popMessage (Skini::Message &message)
| Pop the next message from the queue and write it to the referenced message structure.
void | pushMessage (Skini::Message &message)
| Push the referenced message onto the message stack.
bool | setScoreFile (const char *filename)
| Specify a SKINI formatted scorefile from which messages should be read.
bool | startStdInput ()
| Initiate the "realtime" retreival from stdin of control messages into the queue.
bool | startSocketInput (int port=2001)
| Start a socket server, accept connections, and read "realtime" control messages into the message queue.
bool | startMidiInput (int port=0)
| Start MIDI input, with optional device and port identifiers.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK input control message parser.

This class reads and parses control messages from a variety of sources, such as a scorefile, MIDI port, socket connection, or stdin. MIDI messages are retrieved using the RtMidi class. All other input sources (scorefile, socket, or stdin) are assumed to provide SKINI formatted messages. This class can be compiled with generic, non-realtime support, in which case only scorefile reading is possible.

The various realtime message acquisition mechanisms (from MIDI, socket, or stdin) take place asynchronously, filling the message queue. A call to popMessage() will pop the next available control message from the queue and return it via the referenced Message structure. When a non-realtime scorefile is set, it is not possible to start reading realtime input messages (from MIDI, socket, or stdin). Likewise, it is not possible to read from a scorefile when a realtime input mechanism is running.

When MIDI input is started, input is also automatically read from stdin. This allows for program termination via the terminal window. An __SK_Exit_ message is pushed onto the stack whenever an "exit" or "Exit" message is received from stdin or when all socket connections close and no stdin thread is running.

This class is primarily for use in STK example programs but it is generic enough to work in many other contexts.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Member Function Documentation

## ◆ popMessage()

void stk::Messager::popMessage | ( | Skini::Message & | message | ) |

Pop the next message from the queue and write it to the referenced message structure.

Invalid messages (or an empty queue) are indicated by type values of zero, in which case all other message structure values are undefined. The user MUST verify the returned message type is valid before reading other message values.

## ◆ setScoreFile()

bool stk::Messager::setScoreFile | ( | const char * | filename | ) |

Specify a SKINI formatted scorefile from which messages should be read.

A return value of `true` indicates the call was successful. A return value of `false` can occur if the file is not found, cannot be opened, another file is currently still open, or if a realtime input mechanism is running. Scorefile input is considered to be a non-realtime control mechanism that cannot run concurrently with realtime input.

## ◆ startStdInput()

bool stk::Messager::startStdInput | ( |  | ) |

Initiate the "realtime" retreival from stdin of control messages into the queue.

This function initiates a thread for asynchronous retrieval of SKINI formatted messages from stdin. A return value of `true` indicates the call was successful. A return value of `false` can occur if a scorefile is being read, a stdin thread is already running, or a thread error occurs during startup. Stdin input is considered to be a realtime control mechanism that cannot run concurrently with non-realtime scorefile input.

## ◆ startSocketInput()

bool stk::Messager::startSocketInput | ( | int | port = 2001 | ) |

Start a socket server, accept connections, and read "realtime" control messages into the message queue.

This function creates a socket server on the optional port (default = 2001) and starts a thread for asynchronous retrieval of SKINI formatted messages from socket connections. A return value of `true` indicates the call was successful. A return value of `false` can occur if a scorefile is being read, a socket thread is already running, or an error occurs during the socket server or thread initialization stages. Socket input is considered to be a realtime control mechanism that cannot run concurrently with non-realtime scorefile input.

## ◆ startMidiInput()

bool stk::Messager::startMidiInput | ( | int | port = 0 | ) |

Start MIDI input, with optional device and port identifiers.

This function creates an RtMidiIn instance for MIDI input. The RtMidiIn class invokes a local callback function to read incoming messages into the queue. If `port` = -1, RtMidiIn will open a virtual port to which other software applications can connect (OS X and Linux only). A return value of `true` indicates the call was successful. A return value of `false` can occur if a scorefile is being read, MIDI input is already running, or an error occurs during RtMidiIn construction. Midi input is considered to be a realtime control mechanism that cannot run concurrently with non-realtime scorefile input.

The documentation for this class was generated from the following file:

- Messager.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.